local addon, private = ...
local _statset = {}
_statset["blank"]={}
_statset["blank"]["blank"] =
				{	["Name"] = "Blank",
					["Description"] = "Blank stat set",
					["Stats"] = {
						["armor"]={"Armor", 1, 0, 0, 0},
						["intelligence"]={"Intelligence", 2, 0, 0, 0},
						["dexterity"]={"Dexterity",3, 0, 0, 0},
						["strength"]={"Strength", 4, 0, 0, 0},
						["wisdom"]={"Wisdom", 5, 0, 0, 0},
						["endurance"]={"Endurance", 6, 0, 0, 0},
						["powerSpell"]={"Spell Power", 7, 0, 0, 0},
						["powerAttack"]={"Attack Power", 8, 0, 0, 0},
						["critAttack"]={"Physical Crit", 9, 0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0, 0, 0},
						["critPower"]={"Crit Power", 11, 0, 0, 0},
						["hit"]={"Hit", 12, 0, 0, 0},
						["toughness"]={"Toughness", 13, 0, 0, 0},
						["dodge"]={"Dodge", 14, 0, 0, 0},
						["parry"]={"Parry", 15, 0, 0, 0},
						["block"]={"Block", 16, 0, 0, 0},
						["deflect"]={"Deflect", 17, 0, 0, 0},
						["energyMax"]={"Max Energy", 18, 0, 0, 0},
						["energyRegen"]={"Regen Energy", 19, 0, 0, 0},
						["manaMax"]={"Max Mana", 20, 0, 0, 0},
						["manaRegen"]={"Regen Mana", 21, 0, 0, 0},
						["powerMax"]={"Max Power", 22, 0, 0, 0},
						["powerRegen"]={"Regen Power", 23, 0, 0, 0},
						["stealth"]={"Stealth", 24, 0, 0, 0},
						["stealthDetect"]={"Detect Stealth", 25, 0, 0, 0},
						["xp"]={"XP", 26, 0, 0, 0},
						["movement"]={"Movement", 27, 0, 0, 0},
						["resistAir"]={"Resist Air", 28, 0, 0, 0},
						["resistDeath"]={"Resist Death", 29, 0, 0, 0},
						["resistEarth"]={"Resist Earth", 30, 0, 0, 0},
						["resistFire"]={"Resist Fire", 31, 0, 0, 0},
						["resistLife"]={"Reist Life", 32, 0, 0, 0},
						["resistWater"]={"Resist Water", 33, 0, 0, 0},
						["valor"]={"Valor", 34, 0, 0, 0},
						["vengeance"]={"Vengeance", 35, 0, 0, 0},
						["WeaponDPS"]={"Weapon DPS", 36, 0, 0, 0},
					},
				}

_statset["mage"] = {}
_statset["mage"]["61Harbinger - DPS"] =
				{	["Name"] = "61Harbinger",
					["Description"] = "61 Harbinger - DPS",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, 0.94, 0, 0},
						["wisdom"]={"Wisdom", 5, 0.37, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.29, 0, 0},
						["critPower"]={"Crit Power", 11, 0.81, 0, 0},
					},
				}
_statset["mage"]["Pyrobringer - DPS"] =
				{	["Name"] = "Pyrobringer",
					["Description"] = "Pyrobringer - DPS",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, 0.95, 0, 0},
						["wisdom"]={"Wisdom", 5, 0.38, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1.0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.30, 0, 0},
						["critPower"]={"Crit Power", 11, 0.80, 0, 0},
					},
				}
_statset["mage"]["61Chloro/Dom - Heals"] =
				{	["Name"] = "61Chloro/Dom",
					["Description"] = "Chloromancer with Dominator - Heals",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, 1.27, 0, 0},
						["wisdom"]={"Wisdom", 5, 0.39, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1.0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.32, 0, 0},
						["critPower"]={"Crit Power", 11, 0.60, 0, 0},
					},
				}
_statset["mage"]["61Chloro/Pyro - Heals"] =
				{	["Name"] = "61Chloro/Pyro",
					["Description"] = "Chloromancer with Pyromancer - Heals",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, 1.16, 0, 0},
						["wisdom"]={"Wisdom", 5, 0.37, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1.0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.29, 0, 0},
						["critPower"]={"Crit Power", 11, 0.78, 0, 0},
					},
				}
_statset["mage"]["61Elementalist - DPS"] =
				{	["Name"] = "61Elementalist",
					["Description"] = "61 Elementalist - DPS",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, .94, 0, 0},
						["wisdom"]={"Wisdom", 5, 0.37, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1.0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.28, 0, 0},
						["critPower"]={"Crit Power", 11, .71, 0, 0},
					},
				}
_statset["mage"]["61Archon - Support"] =
				{	["Name"] = "61Archon",
					["Description"] = "61 Archon - Support",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, .96, 0, 0},
						["wisdom"]={"Wisdom", 5, 0.37, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1.0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.31, 0, 0},
						["critPower"]={"Crit Power", 11, .92, 0, 0},
					},
				}
_statset["mage"]["61Warlock - DPS"] =
				{	["Name"] = "61Warlock",
					["Description"] = "61 Warlock - DPS",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, .96, 0, 0},
						["wisdom"]={"Wisdom", 5, 0.41, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1.0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.32, 0, 0},
						["critPower"]={"Crit Power", 11, .84, 0, 0},
					},
				}
_statset["mage"]["61Pyromancer - DPS"] =
				{	["Name"] = "61Pyromancer",
					["Description"] = "61 Pyromancer - DPS",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, .95, 0, 0},
						["wisdom"]={"Wisdom", 5, 0.38, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1.0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.30, 0, 0},
						["critPower"]={"Crit Power", 11, .82, 0, 0},
					},
				}

_statset["rogue"] = {}
_statset["rogue"]["40MM/36SIN/0RS - DPS"] =
				{	["Name"] = "Marksman / Assassin / RiftStalker",
					["Description"] = "40 Marksman, 36 Assassin, 0 RiftStalker",
					["Stats"] = {
						["dexterity"]={"Dexterity",3, .98, 0, 0},
						["strength"]={"Strength", 4, .45, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerAttack"]={"Attack Power", 8, 1, 0, 0},
						["critAttack"]={"Physical Crit", 9, .36, 0, 0},
						["critPower"]={"Crit Power", 11, .90, 0, 0},
						["hit"]={"Hit", 12, .5, 0, 0},
						["WeaponDPS"]={"Weapon DPS", 36, 5, 0, 0},
					},
				}
_statset["rogue"]["61MM/10SIN/5NB - DPS"] =
				{	["Name"] = "Marksman / Assassin / Nightblade",
					["Description"] = "61 Marksman, 10 Assassin, 5 Nightblade",
					["Stats"] = {
						["dexterity"]={"Dexterity",3, .98, 0, 0},
						["strength"]={"Strength", 4, .46, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerAttack"]={"Attack Power", 8, 1, 0, 0},
						["critAttack"]={"Physical Crit", 9, .37, 0, 0},
						["critPower"]={"Crit Power", 11, .93, 0, 0},
						["hit"]={"Hit", 12, .5, 0, 0},
						["WeaponDPS"]={"Weapon DPS", 36, 5, 0, 0},
					},
				}
_statset["rogue"]["61NB/10MM/5TACT - DPS"] =
				{	["Name"] = "Nightblade / Marksman / Tactician",
					["Description"] = "61 Nightblade, 10 Marksman, 5 Tactician",
					["Stats"] = {
						["dexterity"]={"Dexterity",3, .99, 0, 0},
						["strength"]={"Strength", 4, .46, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerAttack"]={"Attack Power", 8, 1, 0, 0},
						["critAttack"]={"Physical Crit", 9, .38, 0, 0},
						["critPower"]={"Crit Power", 11, .66, 0, 0},
						["hit"]={"Hit", 12, .5, 0, 0},
						["WeaponDPS"]={"Weapon DPS", 36, 5, 0, 0},
					},
				}
_statset["rogue"]["42TACT/36MM/0RS - DPS"] =
				{	["Name"] = "Tactician / Marksman / RiftStalker",
					["Description"] = "42 Tactician, 36 Marksman, 0 RiftStalker",
					["Stats"] = {
						["dexterity"]={"Dexterity",3, .97, 0, 0},
						["strength"]={"Strength", 4, .44, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerAttack"]={"Attack Power", 8, 1, 0, 0},
						["critAttack"]={"Physical Crit", 9, .34, 0, 0},
						["critPower"]={"Crit Power", 11, .77, 0, 0},
						["hit"]={"Hit", 12, .5, 0, 0},
						["WeaponDPS"]={"Weapon DPS", 36, 5, 0, 0},
					},
				}
_statset["rogue"]["40BARD/36TACT/0RS - Support"] =
				{	["Name"] = "Bard / Tactician / RiftStalker",
					["Description"] = "40 Bard, 36 Tactician, 0 RiftStalker",
					["Stats"] = {
						["dexterity"]={"Dexterity",3, .91, 0, 0},
						["strength"]={"Strength", 4, .39, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerAttack"]={"Attack Power", 8, 1, 0, 0},
						["critAttack"]={"Physical Crit", 9, .24, 0, 0},
						["critPower"]={"Crit Power", 11, .42, 0, 0},
						["hit"]={"Hit", 12, .5, 0, 0},
						["WeaponDPS"]={"Weapon DPS", 36, 5, 0, 0},
					},
				}
_statset["rogue"]["44NB/32SIN/0MM - DPS"] =
				{	["Name"] = "Nightblade / Assassin / Marksman",
					["Description"] = "44 Nightblade, 32 Assassin, 0 Marksman",
					["Stats"] = {
						["dexterity"]={"Dexterity",3, .95, 0, 0},
						["strength"]={"Strength", 4, .43, 0, 0},
						["endurance"]={"Endurance", 6, .10, 0, 0},
						["powerAttack"]={"Attack Power", 8, 1, 0, 0},
						["critAttack"]={"Physical Crit", 9, .32, 0, 0},
						["critPower"]={"Crit Power", 11, .66, 0, 0},
						["hit"]={"Hit", 12, .5, 0, 0},
						["WeaponDPS"]={"Weapon DPS", 36, 5, 0, 0},
					},
				}
_statset["rogue"]["61RS/8RNG/7BARD - Tank"] =
				{	["Name"] = "Riftstalker / Ranger / Bard",
					["Description"] = "61 Riftstalker, 8 Ranger, 7 Bard",
					["Stats"] = {
						["armor"]={"Armor", 1, .10, 0, 0},
						["dexterity"]={"Dexterity",3, 1.404, 0, 0},
						["strength"]={"Strength", 4, .657, 0, 0},
						["endurance"]={"Endurance", 6, 2.845, 0, 0},
						["dodge"]={"Dodge", 14, .631, 0, 0},
						["parry"]={"Parry", 15, .624, 0, 0},
						["deflect"]={"Deflect", 17, .706, 0, 0},
					},
				}

_statset["cleric"] = {}
_statset["cleric"]["61Inquisitor - DPS"] =
				{	["Name"] = "61 Inquisitor",
					["Description"] = "61 Inquisitor - DPS",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, 0.42, 0, 0},
						["wisdom"]={"Wisdom", 5, 0.94, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1.0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.30, 0, 0},
						["critPower"]={"Crit Power", 11, 0.83, 0, 0},
					},
				}
_statset["cleric"]["61Shaman - DPS"] =
				{	["Name"] = "61 Shaman",
					["Description"] = "61 Shaman - DPS",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, 0.4, 0, 0},
						["wisdom"]={"Wisdom", 5, 0.89, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1.0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.30, 0, 0},
						["critPower"]={"Crit Power", 11, 0.69, 0, 0},
					},
				}
_statset["cleric"]["61Sentinel - Heals"] =
				{	["Name"] = "61 Sentinel",
					["Description"] = "61 Sentinel - Heals",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, 0.37, 0, 0},
						["wisdom"]={"Wisdom", 5, .93, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1.0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.25, 0, 0},
						["critPower"]={"Crit Power", 11, 0.47, 0, 0},
					},
				}
_statset["cleric"]["61Purifier - Heals"] =
				{	["Name"] = "61 Purifier",
					["Description"] = "61 Purifier - Heals",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, 0.39, 0, 0},
						["wisdom"]={"Wisdom", 5, .94, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1.0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.26, 0, 0},
						["critPower"]={"Crit Power", 11, 0.57, 0, 0},
					},
				}
_statset["cleric"]["61Warden - Heals"] =
				{	["Name"] = "61 Warden",
					["Description"] = "61 Warden - Heals",
					["Stats"] = {
						["intelligence"]={"Intelligence", 2, 0.35, 0, 0},
						["wisdom"]={"Wisdom", 5, .94, 0, 0},
						["powerSpell"]={"Spell Power", 7, 1.0, 0, 0},
						["critSpell"]={"Spell Crit", 12, 0.25, 0, 0},
						["critPower"]={"Crit Power", 11, 0.49, 0, 0},
					},
				}				
_statset["cleric"]["61Justicar - Tank"] =
				{	["Name"] = "61 Justicar / 9 Inquisitor / 6 Shaman",
					["Description"] = "61 Justicar - Tank",
					["Stats"] = {
						["armor"]={"Armor", 1, .10, 0, 0},
						["intelligence"]={"Intelligence", 2, .672, 0, 0},
						["wisdom"]={"Wisdom", 5, 1.421, 0, 0},
						["endurance"]={"Endurance", 6, 3.006, 0, 0},
						["dodge"]={"Dodge", 14, .640, 0, 0},
						["parry"]={"Parry", 15, .648, 0, 0},
						["block"]={"Block", 16, .705, 0, 0},
					},
				}

_statset["warrior"] = {}
_statset["warrior"]["58PAL/18RV - Tank"] =
				{	["Name"] = "Paladin / Reaver",
					["Description"] = "58 Paladin, 18 Reaver - Tank",
					["Stats"] = {
						["armor"]={"Armor", 1, .10, 0, 0},
						["dexterity"]={"Dexterity",3, .67, 0, 0},
						["strength"]={"Strength", 4, 1.529, 0, 0},
						["endurance"]={"Endurance", 6, 2.461, 0, 0},
						["dodge"]={"Dodge", 14, .67, 0, 0},
						["parry"]={"Parry", 15, .69, 0, 0},
						["block"]={"Block", 16, .839, 0, 0},
					},
				}
_statset["warrior"]["58PAL/18VK - Tank"] =
				{	["Name"] = "Paladin / Void Knight",
					["Description"] = "58 Paladin, 18 Void Knight - Tank",
					["Stats"] = {
						["armor"]={"Armor", 1, .10, 0, 0},
						["dexterity"]={"Dexterity",3, .656, 0, 0},
						["strength"]={"Strength", 4, 1.521, 0, 0},
						["endurance"]={"Endurance", 6, 2.479, 0, 0},
						["dodge"]={"Dodge", 14, .656, 0, 0},
						["parry"]={"Parry", 15, .675, 0, 0},
						["block"]={"Block", 16, .845, 0, 0},
					},
				}
_statset["warrior"]["61VK/15PAL - Tank"] =
				{	["Name"] = "Void Knight / Paladin",
					["Description"] = "61 Void Knight, 15 Paladin - Tank",
					["Stats"] = {
						["armor"]={"Armor", 1, .10, 0, 0},
						["dexterity"]={"Dexterity",3, .656, 0, 0},
						["strength"]={"Strength", 4, 1.425, 0, 0},
						["endurance"]={"Endurance", 6, 2.475, 0, 0},
						["dodge"]={"Dodge", 14, .656, 0, 0},
						["parry"]={"Parry", 15, .676, 0, 0},
						["block"]={"Block", 16, .749, 0, 0},
					},
				}
_statset["warrior"]["61WL/11/4 - DPS"] =
				{	["Name"] = "Warlord /  / ",
					["Description"] = "61 Warlord - DPS",
					["Stats"] = {
						["dexterity"]={"Dexterity",3, .58, 0, 0},
						["strength"]={"Strength", 4, 1.34, 0, 0},
						["powerAttack"]={"Attack Power", 8, 1, 0, 0},
						["critAttack"]={"Physical Crit", 9, .39, 0, 0},
						["critPower"]={"Crit Power", 11, 1.44, 0, 0},
						["WeaponDPS"]={"Weapon DPS", 36, 9.36, 0, 0},
					},
				}
_statset["warrior"]["61TP/15/0 - DPS"] =
				{	["Name"] = "Tempest /  / ",
					["Description"] = "61 Tempest - DPS",
					["Stats"] = {
						["dexterity"]={"Dexterity",3, .43, 0, 0},
						["strength"]={"Strength", 4, .98, 0, 0},
						["powerAttack"]={"Attack Power", 8, 1, 0, 0},
						["critAttack"]={"Physical Crit", 9, .3, 0, 0},
						["critPower"]={"Crit Power", 11, .97, 0, 0},
						["WeaponDPS"]={"Weapon DPS", 36, 5.87, 0, 0},
					},
				}
_statset["warrior"]["61PA/10/5 - DPS"] =
				{	["Name"] = "Paragon /  / ",
					["Description"] = "61 Paragon - DPS",
					["Stats"] = {
						["dexterity"]={"Dexterity",3, .51, 0, 0},
						["strength"]={"Strength", 4, 1.2, 0, 0},
						["powerAttack"]={"Attack Power", 8, 1, 0, 0},
						["critAttack"]={"Physical Crit", 9, .32, 0, 0},
						["critPower"]={"Crit Power", 11, 1.11, 0, 0},
						["WeaponDPS"]={"Weapon DPS", 36, 6.36, 0, 0},
					},
				}
_statset["warrior"]["61RB/10/5 - DPS"] =
				{	["Name"] = "Riftblade /  / ",
					["Description"] = "61 Riftblade - DPS",
					["Stats"] = {
						["dexterity"]={"Dexterity",3, .41, 0, 0},
						["strength"]={"Strength", 4, .96, 0, 0},
						["powerAttack"]={"Attack Power", 8, 1, 0, 0},
						["critAttack"]={"Physical Crit", 9, .27, 0, 0},
						["critPower"]={"Crit Power", 11, .74, 0, 0},
						["WeaponDPS"]={"Weapon DPS", 36, 4.65, 0, 0},
					},
				}

local function sorter(a,b)
	return a[1] < b[1]
end

local function GetStatsInOrder()
	local a = {}
    for i, n in pairs(_statset["blank"]["blank"]["Stats"]) do table.insert(a, {n[2], n[1], i}) end
    table.sort(a, sorter)
	return a
end

local function GetStatSets(_calling)
	local _iRec = {}

	for setname, statrec in pairs(_statset[_calling]) do
		if setname ~= "blank" then table.insert(_iRec, setname) end
	end

	return _iRec
end

local function GetStatSet(_class, _rec)
	local _iRec = {}

	for statname, statrec in pairs(_statset[_class][_rec..""]["Stats"]) do
		_iRec[statname..""] = {["StatName"]=statname, ["StatWeight1"]=statrec[3], ["StatCap"]=statrec[4], ["StatWeight2"]=statrec[5]}
	end
	return _iRec
end

local function GetNewStatRecord()
	local _iRec = {}
	_iRec = {["StatName"]="", ["StatWeight1"]=0, ["StatCap"]=0, ["StatWeight2"]=0}
	return _iRec
end


function GetStatData()
	local _ret = {}

	_ret.GetStatsInOrder = GetStatsInOrder
	_ret.GetStatSet = GetStatSet
	_ret.GetStatSets = GetStatSets
	_ret.GetNewStatRecord = GetNewStatRecord

	return _ret
end
